#!/home/pak04955/bin/ruby -Ke
# -*- mode: ruby -*-

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

require 'cgi.rb'
require 'diary-sub.rb'
require 'diary-updateindex.rb'
require 'diary-validcheck.rb'

$SAFE = 1

def error_out(s)
  print "<p>error: #{s}\n"
end

def header_out(enc)
  print <<EOF
Content-Type: text/html; charset=#{enc}

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML LANG="ja">
<head>
  <link rel="start" href="http://www2.airnet.ne.jp/pak04955/">
  <link rel="copyright" href="http://www2.airnet.ne.jp/pak04955/copyright.htm">
  <LINK rel="stylesheet" href="./default.css" type="text/css">
  <TITLE>diary edit</title>
  <META name="ROBOTS" content="NOINDEX, NOFOLLOW">
</head>
<body>
EOF
end

def edit_pane(y, m, d)
  print <<EOF
<h1>Խ</h1>
<form method=post enctype="multipart/form-data" action="./diary-edit.cgi">
  <input type=hidden name="action" value="confirm">
  <input type=hidden name="y" value=#{y}>
  <input type=hidden name="m" value=#{m}>
  <input type=hidden name="d" value=#{d}>
<table border=0>
  <tr><th nowrap>ա<td width="100%">#{y}ǯ#{m}#{d}
  <tr><td colspan=2><textarea rows=30 cols=70 name=body>
EOF

  file = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d", y, y, m, d)
  begin 
    fp = File.open(file, "r") # lock
    
    while line = fp.gets
      break if line.gsub(/[\r\n]/, '') == ''
    end
    while line = fp.gets
      print html_escape(j2e(line.gsub(/[\r\n]/, ''))), "\n"
    end
  rescue SystemCallError
    # 
  ensure
    fp.close if fp
  end

  print <<'EOF'
</textarea>
  <tr><td colspan=2><input type=submit name="submit" value="ǧ">
</table>
</form>
EOF
end

def edit_mode(cgi)
  header_out("EUC-JP")

  if !cgi['d'].empty? && cgi['d'][0] =~ /([0-9][0-9][0-9][0-9])([0-1][0-9])([0-3][0-9])/
    day = Time.local($1, $2, $3)
  else
    day = Time.now
    day -= 60 * 60 * 24 if day.hour < 3
  end
  edit_pane(day.year, day.mon, day.day)
end

def confirm_show(cgi)
  header_out("ISO-2022-JP")

  if cgi['y'].empty? || cgi['m'].empty? || cgi['d'].empty?
    error_out(e2j("դꤵƤʤ"))
    return
  end
  y = cgi['y'][0].read.to_i
  m = cgi['m'][0].read.to_i
  d = cgi['d'][0].read.to_i
  file = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d.tmp", y, y, m, d)
  begin
    fp = File.open(file, "w")
    fp.flock(File::LOCK_EX)
    fp.print "Content-Type: text/html; charset=ISO-2022-JP\r\n"
    fp.print "\r\n"

    body = cgi['body'][0].read.split(/\r?\n/)
    body.each {|line|
      fp.print e2j(line), "\r\n"
    }
  rescue SystemCallError
    error_out(e2j("եν񤭹ߤ˼: ") + file)
    return
  ensure
    fp.close if fp
  end

  print "<h1>", e2j("ǧ"), "</h1>\n"
  print e2j("<p>#{y}ǯ#{m}#{d}"), "\n"
  print_day_sub(y, m, d, file)
  print "<hr>\n"
  check_tag(y, m, d, file)

  print <<EOF
<form method=post action="./diary-edit.cgi">
  <input type=hidden name="action" value="update">
  <input type=hidden name="y" value=#{y}>
  <input type=hidden name="m" value=#{m}>
  <input type=hidden name="d" value=#{d}>
  
  <input type=submit name="submit" value="#{e2j("")}">
</form>
EOF
end

def update_data(cgi)
  header_out("EUC-JP")

  if cgi['y'].empty? || cgi['m'].empty? || cgi['d'].empty?
    error_out("դꤵƤʤ")
    return
  end
  y = cgi['y'][0]
  m = cgi['m'][0]
  d = cgi['d'][0]
  tmpfile = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d.tmp", y, y, m, d)
  file = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d", y, y, m, d)
  if !FileTest.exist?(tmpfile)
    error_out("ե뤬ʤ")
    return
  end
  File.rename(tmpfile, file)

  print <<EOF
<h1>λ</h1>
<p>#{y}ǯ#{m}#{d}ʬΥǡ򹹿ޤ
<p><a href="index.htm">ȥåץڡ</a> &gt;
  <a href="ramble.htm">ﴶϿ</a> &gt;
  <a href="./diary.rb?m=#{sprintf("%04d%02d", y, m)}">#{y}ǯ#{m}οﴶ</a>
EOF
  #fork {
    update_key_database()
  #  exit
  #}
end

  # main

  cgi = CGI.new
  if cgi['action'].empty?
    action = "edit" 
  elsif defined? cgi['action'][0].read
    action = cgi['action'][0].read
  else
    action = cgi['action'][0]
  end

  case action
  when 'confirm'
    confirm_show(cgi)
  when 'update'
    update_data(cgi)
  else # edit
    edit_mode(cgi)
  end

  diary_footer_out()
  print "</body>\n"
  print "</html>\n"
