#!/home/pak04955/bin/ruby -KN
# -*- mode: ruby -*-

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

# 󥯤

require 'date'
require 'diary-sub.rb'

$SAFE = 1

def result_header_out()
  print <<EOF
Content-Type: text/html; charset=EUC-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML LANG="ja">
<head>
  <link rel="start" href="http://www2.airnet.ne.jp/pak04955/">
  <link rel="copyright" href="http://www2.airnet.ne.jp/pak04955/copyright.htm">
  <LINK rel="stylesheet" href="./default.css" type="text/css">
  <TITLE>search result</title>
  <META name="ROBOTS" content="NOINDEX, NOFOLLOW">
</head>
<body>
EOF
end

def search_external(year, mon, day, fname)
  begin
    fp = File.open(fname, "r")
    while line = fp.gets
      break if line.gsub(/[\r\n]/, '') == ''
    end

    found = false
    state = 1
    while line = j2e(fp.gets)
      case state
      when 1 # Ϥʸ
        while line =~ /<[aA][ \t\r\n]+([^>]+)>/
          line = $'
          attrs = get_attrs($1.strip)
          uri = attrs['href']
          if uri =~ /^http:/ || uri =~ /^ftp:/
            title = ''
            state = 2
            break
          end
        end
        redo if state != 1
      when 2 # a
        if line =~ /<\/[aA]>/
          title << $`
          line = $'
          if !found
            printf "<p><a href=\"./diary.rb?m=%04d%02d#%02d\">%04d.%02d.%02d</a>\n",
                   year, mon, day, year, mon, day
            print "<ul>\n"
            found = true
          end
          print "  <li><a href=\"#{uri}\">#{title}</a>\n"
          state = 1
          redo
        else
          title << " " + line.strip
        end
      end
    end
    print "</ul>\n" if found
  rescue SystemCallError
    print "fatal error: #{fname}\n"
    exit
  ensure
    fp.close if fp
  end
end

  # main

  result_header_out()

  print "<h1>󥯰</h1>\n"

  Date.today.downto(DIARY_START_DAY) {|day|
    fname = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d",
                                     day.year, day.year, day.mon, day.day)
    next if !FileTest.exist?(fname)
    search_external(day.year, day.mon, day.day, fname)
  }

  diary_footer_out()
  print "</body>\n"
  print "</html>\n"
