#!/home/pak04955/bin/ruby -Ke
# -*- mode: ruby -*-

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

require "cgi.rb"
require "nkf"
require 'diary-sub.rb'

$SAFE = 1

def result_header_out()
  print <<EOF
Content-Type: text/html; charset=EUC-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML LANG="ja">
<head>
  <link rel="start" href="http://www2.airnet.ne.jp/pak04955/">
  <link rel="copyright" href="http://www2.airnet.ne.jp/pak04955/copyright.htm">
  <LINK rel="stylesheet" href="./default.css" type="text/css">
  <TITLE>search result</title>
  <META name="ROBOTS" content="NOINDEX, NOFOLLOW">
</head>
<body>
EOF
end

def search_text(year, mon, day, fname, text)
  begin
    f = File.open(fname, "r")

    found = false
    while line = j2e(f.gets)
      line.gsub! /[ \t\r\n]/, ''
      line.gsub! /<[a-zA-Z\/][^>]*>/, '' # ä

      # Ȥä
      while (pos = line.index('<!--')) != nil
        if (postail = line.index('-->', pos + 4)) != nil
          line = line[0, pos] + line[postail + 3, line.length]
        else
          # ʣԤΥ
          while line = f.gets
            if (postail = line.index('-->')) != nil
              line = line[postail + 3, line.length]
              break
            end
          end
        end
      end
      
      if idx = line.upcase.index(text.upcase)
        if found == false
          printf "<p><a href=\"./diary.rb?m=%04d%02d#%02d\">%04d.%02d.%02d</a><br>\n",
                 year, mon, day, year, mon, day
          found = true
        end
        print line[0, idx], "<font color=\"red\">", line[idx, text.length], "</font>", line[idx + text.length, line.length], "<br>\n"
      end
    end
  rescue SystemCallError
    # empty
  ensure
    f.close if f
  end
end

  # main

  cgi = CGI.new
  text = ""
  text = NKF.nkf("-J -e -m0", cgi['text'][0]) if !cgi['text'].empty?
  text.gsub! /[ \t\r\n]+/, ''
  text = html_escape(text)
  if text == ""
    print "Status: ", (ENV['SERVER_PROTOCOL'] == "HTTP/1.1" ? "303" : "302"), "\n"
    print "Location: http://www2.airnet.ne.jp/pak04955/\n"
    print "\n"
    exit
  end

  result_header_out()
  
  print "<h1></h1>\n"
  print "<p>#{text}פθ̡\n"

  Date.today.downto(DIARY_START_DAY) {|day|
    fname = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d",
                                     day.year, day.year, day.mon, day.day)
    next if !FileTest.exist?(fname)
    search_text(day.year, day.mon, day.day, fname, text)
  }

  diary_footer_out()
  print "</body>\n"
  print "</html>\n"
