
# -*- mode: ruby -*-

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

require 'nkf'
require 'cgi'

require './diary-conf.rb'
HREF_URI = './diary.rb?m=%04d%02d#%02d'

DAYNAMES_JA = ["", "", "", "", "", "", ""]

def day_of_week(jd)
  # ˤʤ0֤
  (jd + 1) % 7
end

def e2j(s)
  NKF.nkf("-j -E -m0", s) # eucJP -> iso-2022-jp
end

def j2e(s)
  if s
    NKF.nkf('-e -J -m0', s)
  else
    nil
  end
end

def html_escape(s)
  # ʸ򥨥פ
  if s 
    r = s.dup
    r.gsub! '&', '&amp;'
    r.gsub! '"', '&quot;'
    r.gsub! '<', '&lt;'
    r.gsub! '>', '&gt;'
    r
  else
    nil
  end
end

def get_attrs(s)
  r = Hash.new
  while s =~ /([a-z][a-z0-9]*)[ \t\r\n]*=[ \t\r\n]*\"([^\"]*)\"/
    attr_name = $1
    attr_value = $2.strip
    s = $'
    r[attr_name] = attr_value
  end
  r
end

D_START_TAG = /<d:([a-z0-9._:-]+)[ \t\r\n]*([^>]*)>/

def print_day_sub(y, mon, day, file)
  # ʸɽ
  mark_count = 2
  begin
    f = File.open(file, "r") # lockɬפʤ
    while line = f.gets
      break if line.gsub(/[\r\n]/, '') == ""
    end

    state = 1
    while line = f.gets
      case state
      when 1
        while line =~ D_START_TAG
          print $`
          line = $'
            
          tag = $1
          attrs = get_attrs($2.strip)
          case tag
          when 'link'
            # <d:link href="2000.05.20/1"/>
            u = attrs['href'].split('/')
            d_ = u[0].split('.')
            ref = sprintf(HREF_URI, d_[0].to_i, d_[1].to_i, d_[2].to_i)
            ref += u[1] if u.size > 1
            print "<a href=\"#{ref}\">#{attrs['href']}</a>"
          when 'mark'
            # <d:mark/>
            print "<p><a href=\"" + sprintf(HREF_URI, y, mon, day) + sprintf("%02d", mark_count) + "\" name=\"" + sprintf("%02d%02d", day, mark_count) + "\">@</a>\n"
            mark_count += 1
          when 'category'
            # <d:category name="anchor">Ƥꤣ1 ƥ꡼2 c3</d:category>
            print "<h3 class=\"diary\"><a href=\"" + sprintf(HREF_URI, y, mon, day) + attrs['name'] + "\" name=\"" + sprintf("%02d", day) + attrs['name'] + "\">"
            print "@</a> "
            categories = ''
            state = 2
            break
          when 'title'
            # <d:title name="anchor" keywords="word word word">Ȥ</d:title>
            print "<h3 class=\"diary\"><a href=\"" + sprintf(HREF_URI, y, mon, day) + attrs['name'] + "\" name=\"" + sprintf("%02d", day) + attrs['name'] + "\">"
            print "@</a> "
            attrs['keywords'].split(/[ \t\r\n]+/).each {|k|
              print "<a class=\"category\" href=\"diary-list.rb?k=#{CGI.escape(j2e(k))}\">[#{k}]</a> "
            }
            title = ''
            state = 3
            break
          end
        end
        redo if state != 1
        print line
      when 2
        if line =~ '</d:category>'
          categories << $`
          line = $'
          categories.split(/[ \t\r\n]+/).each {|k|
            print "<a class=\"category\" href=\"diary-list.rb?k=#{CGI.escape(j2e(k))}\">[#{k}]</a> "
          }
          print "</h3>\n"
          state = 1
          redo
        else
          categories << " " + line.strip
        end
      when 3
        if line =~ '</d:title>'
          title << $`
          line = $'
          print "#{title}</h3>\n"
          state = 1
          redo
        else
          title << " " + line.strip
        end
      end
    end
  rescue SystemCallError
    print "<p>error: cannot open file\n"
  ensure
    f.close if f
  end
end

def diary_footer_out()
  print <<'EOF'
<hr>
Q's WebDiary Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
EOF
end #'
