
# -*- mode: ruby -*-

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

# ƥꡦǥå򹹿


# XML Schema Part 2: Datatypes
#      http://www.w3.org/TR/xmlschema-2/

# Extensible Markup Language (XML) 1.0 (Second Edition)
#      http://www.w3.org/TR/REC-xml

# HTML 4.01 Specification
#      http://www.w3.org/TR/html401/

# NMTOKENS϶Ƕڤ -> keywords϶Ƕڤ뤳Ȥˤ
# <d:title name="hoge" keywords="Ruby Java&#20;CORBA ܸ">Ȥ</d:title>

require 'date'
require 'nkf'
require 'pstore'

require 'diary-sub.rb'

D_START_TAG = /<d:([a-z0-9._:-]+)[ \t\r\n]*([^>]*)>/
D_TITLE_END_TAG = /<\/d:title>/
D_CATEGORY_END_TAG = /<\/d:category>/

def update_db(keywords, path_name, subject)
  keywords = keywords.strip.split(/[ \t\r\n]+/).sort.join(' ')
  keywords.split(' ').each {|x|
    $key_db.transaction do
      if $key_db.root?(x)
        $key_db[x] = $key_db[x] + "\n" + [path_name, keywords, html_escape(subject)].join('&')
      else
        $key_db[x] = [path_name, keywords, html_escape(subject)].join('&')
      end
    end
  }
end

def collect_keywords(year, mon, day, fname)
  begin
    fp = File.open(fname, "r")
    while line = fp.gets
      break if line.gsub(/[\r\n]/, '') == ''
    end

    state = 1
    while line = j2e(fp.gets)
      case state
      when 1 # Ϥʸ
        while line =~ D_START_TAG
          line = $'
          
          tag = $1
          attrs = get_attrs($2.strip)
          case tag
          when 'title'
            if !attrs['name'] || !attrs['keywords']
              print "fatal error: illegal start tag: #{year}/#{mon}/#{day}\n"
              exit
            end
            path_name = sprintf("%04d.%02d.%02d/%s", year, mon, day, attrs['name'])
            keywords = attrs['keywords']
            subject = ''
            state = 2
            break
          when 'category'
            if !attrs['name']
              print "fatal error: illegal start tag: #{year}/#{mon}/#{day}\n"
              exit
            end
            path_name = sprintf("%04d.%02d.%02d/%s", year, mon, day, attrs['name'])
            keywords = ''
            state = 3
            break
          end
        end
        redo if state != 1
      when 2 # <d:title>
        if line =~ D_TITLE_END_TAG 
          subject << $`
          line = $'
          update_db(keywords, path_name, subject)
          state = 1
          redo
        else
          subject << " " + line.strip
        end
      when 3 # <d:category>
        if line =~ D_CATEGORY_END_TAG
          keywords << $`
          line = $'
          update_db(keywords, path_name, '(ȥʤ)')
          state = 1
          redo
        else
          keywords << " " + line.strip
        end
      end
    end
  rescue SystemCallError
    print "fatal error: #{fname}\n"
    exit
  ensure
    fp.close if fp
  end
end

def update_key_database()
  $key_db = PStore.new(DIARY_DATA_DIR + "/keyindex")
  $key_db.transaction do
    $key_db.roots.each {|x|
      $key_db.delete(x)
    }
  end

  (DIARY_START_DAY .. Date.today).each {|day|
    fname = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d",
                             day.year, day.year, day.mon, day.day)
    next if !FileTest.exist?(fname)
    collect_keywords(day.year, day.mon, day.day, fname)
  }
end

if $0 == __FILE__
  # main
  update_key_database()
end
