

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

require 'date'
require 'diary-sub.rb'

# Ĵ٤

def stag_error(year, mon, day, tag)
  print "error: illegal start tag: #{year}/#{mon}/#{day}: #{tag}\n"
end

def check_tag(year, mon, day, fname)
  begin
    fp = File.open(fname, "r")
    while line = fp.gets
      break if line.gsub(/[\r\n]/, '') == ''
    end
    
    while line = j2e(fp.gets)
      while true
        if line =~ /<d:([a-z0-9._:-]+)[ \t\r\n]*([^>]*)>/
          line = $'

          tag = $1
          attrs = get_attrs($2.strip)
          case tag
          when 'link'
            stag_error(year, mon, day, tag) if !attrs['href']
          when 'mark'
            stag_error(year, mon, day, tag) if attrs.size > 0
          when 'category'
            stag_error(year, mon, day, tag) if !attrs['name']
          when 'title'
            stag_error(year, mon, day, tag) if !attrs['name'] || !attrs['keywords']
          else
            stag_error(year, mon, day, tag)
          end
        elsif line =~ /<\/d:([^>]*)>/
          tag = $1
          line = $'
          case tag
          when 'category'
          when 'title'
          else
            print "error: illegal end tag: #{year}/#{mon}/#{day}: #{tag}\n"
          end
        else
          break
        end
      end
    end
  rescue SystemCallError
    print "fatal error: cannot open file: #{year}/#{mon}/#{day}\n"
    exit
  ensure
    fp.close if fp
  end
end

if $0 == __FILE__
  # main
  (DIARY_START_DAY .. Date.today).each {|day|
    fname = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d", day.year, day.year, day.mon, day.day)
    next if !FileTest.exist?(fname)
    check_tag(day.year, day.mon, day.day, fname)
  }
end
