#!/home/pak04955/bin/ruby -Ke
# -*- mode: ruby -*-

# Web
# Copyright (c) 1999-2001 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www2.airnet.ne.jp/pak04955/

require 'date'
require 'cgi'

require './diary-sub.rb'
require './banner.rb'
require './banner2.rb'
require './referer.rb'
SCRIPT_PATH = "."

$SAFE = 1

def print_day(y, mon, day)
  jd = Date.exist?(y, mon, day)
  file = DIARY_DATA_DIR + sprintf("/%04d/%04d%02d%02d", y, y, mon, day)
  return 0 if !jd || !FileTest.exist?(file)
  print <<EOF
<table border=0 cellspacing=0 class="diary-day">
<tr>
  <td class="diary-header">
    <a class=day href="#{sprintf(HREF_URI, y, mon, day)}" name="#{sprintf("%02d", day)}">#{sprintf("%04d.%02d.%02d", y, mon, day)} (#{e2j(DAYNAMES_JA[day_of_week(jd)])})</a>
  <td nowrap class="diary-header-b">
  <a class=day href="#{SCRIPT_PATH}/diary-edit.cgi?d=#{sprintf("%04d%02d%02d", y, mon, day)}">[edit]</a>
  <a class=day href="#{SCRIPT_PATH}/diary-edit.cgi">[new]</a>
</tr>
</table>
EOF

  print_day_sub(y, mon, day, file)
  return 1
end

def one_liner()
  q = rand(4 * 2 * 2 + 2 * 3)
  if q < 4 * 2 * 2
    a = %w(Ϥʤ ޤä դդ ؤʤؤ)
    s = a[rand(a.size)]
    s << ''
    a = %w( Ƶۤ)
    s << a[rand(a.size)]
    a = %w( )
    s << a[rand(a.size)]
    s << ''
  else
    s = 'ޤޤʤʤ'
    a = %w( )
    s << a[rand(a.size)]
    s << ''
    a = %w( ˤ )
    s << a[rand(a.size)]
    s << ''
  end
  return s
end

def header_out(year, mon)
  print <<EOF
Content-Type: text/html; charset=ISO-2022-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML LANG="ja">
<HEAD>
  <meta http-equiv="Content-Language" content="ja">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <link rel="stylesheet" href="./default.css" type="text/css" charset="Shift_JIS">
  <link rel="start" href="http://www2.airnet.ne.jp/pak04955/">
  <link rel="copyright" href="./copyright.htm">
  <TITLE>ramble #{sprintf("%04d.%02d", year, mon)}</TITLE>
  <BASE target="_top">
<style type="text/css">
  td {
    background-color: transparent;
    background-image: none;
  }
</style>
</head>
<body>
EOF
end

def search_form()
  print <<EOF
<form method=GET action="./diary-search.cgi">
  <p>#{e2j("ﴶΤ1999.08.01򸡺")}<input type=text name="text" value="">
  <input type=submit value="#{e2j("ʸ")}"><br>
  <a href="./diary-list.rb">#{e2j("[ƥ]")}</a>
  <a href="./diary-external.cgi">#{e2j("[󥯰]")}</a>
</form>
EOF
end

def cgi_mode()
  cgi = CGI.new
  if !cgi['m'].empty? && cgi['m'][0] =~ /([0-9][0-9][0-9][0-9])([0-1][0-9])/
    year = $1.to_i
    mon = $2.to_i
  else
    t = Time.now
    year = t.year
    mon = t.mon
  end
  pagename = "ramble" + sprintf("%04d%02d", year, mon)

  header_out(year, mon)
  banner_head_out(pagename)
  
  print <<EOF
<br>
<br>

<hr>
<a href="./index.htm">#{e2j("ȥåץڡ")}</a> &gt; <a href="./ramble.htm">#{e2j("ﴶϿ")}</a> &gt;
EOF

  hstr = e2j("#{year}ǯ#{mon}οﴶ")
  print "<h1>#{hstr}</h1>\n"
  print "<p>", e2j(one_liner()), "\n"
  search_form()

  31.downto(1) {|d|
    print_day(year, mon, d)
  }

  print <<EOF
<hr>
<a href="index.htm">#{e2j("ȥåץڡ")}</a> &gt; <a href="ramble.htm">#{e2j("ﴶϿ")}</a> &gt; #{hstr}
EOF

  log_referer()
  banner_footer_out()
  print "</body>\n"
  print "</html>\n"
end

def ssi_mode()
  if ARGV[0] && ARGV[1]
    # ʬɽ
    y = ARGV[0].to_i
    m = ARGV[1].to_i
    31.downto(1) {|d|
      print_day(y, m, d)
    }
  else
    # ǿ5ʬɽ
    print "<p>", e2j(one_liner()), "\n"
    search_form()

    print "<ul>\n"
    t = Time.now
    i = 3
    while i > 0
      mstr = sprintf("%04d%02d", t.year, t.mon)
      print "  <li><a href=\"#{SCRIPT_PATH}/diary.rb?m=#{mstr}\">", e2j("#{t.year}ǯ#{t.mon}οﴶ"), "</a>\n"
      if t.mon == 1
        t = Time.local(t.year - 1, 12, 1)
      else
        t = Time.local(t.year, t.mon - 1, 1)
      end
      i -= 1
    end
    print "  <li><a href=\"ramble.htm\">", e2j("ﴶϿ"), "</a>\n"
    print "</ul>\n"

    # ǿ5ɽ
    ser = Date.today
    i = 0
    while i < 5
      i += 1 if print_day(ser.year, ser.mon, ser.day) != 0
      ser -= 1
    end
  end
end

  # begin of main

  if ENV['DOCUMENT_URI']
    ssi_mode()
  else
    cgi_mode()
  end

